// AstVisitor.h

#pragma once

#ifndef _AST_VISITOR_H_
#define _AST_VISITOR_H_

//------------------------------------------------------------------------------

struct CsNode;
//struct CsUsingDirective;
struct CsUsingAliasDirective;
struct CsUsingNamespaceDirective;
//struct CsTypeSpecifiers;
struct CsTypeRef;
struct CsSimpleName;
struct CsLiteral;
struct CsEmbeddedTypeMemberAccess;
struct CsThisAccess;
struct CsBaseMemberAccess;
struct CsBaseIndexerAccess;
struct CsTypeofExpression;
struct CsCheckedExpression;
struct CsUncheckedExpression;
struct CsLockStatement;
struct CsSizeofExpression;
struct CsParenthesizedExpression;
struct CsNewObjectExpression;
struct CsNewArrayExpression;
struct CsInvocationExpression;
struct CsElementAccess;
struct CsMemberAccess;
struct CsPointerMemberAccess;
struct CsPostIncrementDecrementExpression;
struct CsBinaryExpression;
struct CsAsIsExpression;
struct CsConditionalExpression;
struct CsOperatorUnaryExpression;
struct CsPreIncrementDecrementExpression;
struct CsCastUnaryExpression;
struct CsAssignmentExpression;
struct CsExpressionList;
struct CsNamedArgument;
struct CsAttribute;
struct CsAttributeSection;
struct CsAttributes;
struct CsTypeBase;
struct CsClass;
struct CsStruct;
struct CsInterface;
struct CsEnumMember;
struct CsEnum;
struct CsFormalParameter;
struct CsFormalParameterList;
struct CsDelegate;
struct CsNamespace;
struct CsArgument;
struct CsArgumentList;
struct CsBlock;
struct CsLabel;
struct CsLabeledStatement;
struct CsEmptyStatement;
struct CsExpressionStatement;
struct CsDeclarationStatement;
struct CsLocalConstantDeclarator;
struct CsLocalConstantDeclaration;
struct CsIfStatement;
struct CsSwitchLabel;
struct CsSwitchSection;
struct CsSwitchStatement;
struct CsWhileStatement;
struct CsDoWhileStatement;
struct CsLocalVariableDeclarator;
struct CsLocalVariableDeclaration;
struct CsStatementExpressionList;
struct CsForStatement;
struct CsForeachStatement;
struct CsBreakStatement;
struct CsContinueStatement;
struct CsGotoStatement;
struct CsReturnStatement;
struct CsThrowStatement;
struct CsCatchClause;
struct CsTryStatement;
struct CsCheckedStatement;
struct CsUncheckedStatement;
struct CsUsingStatement;
struct CsUnsafeStatement;
struct CsFixedPointDeclarator;
struct CsFixedStatement;
struct CsStackAllocExpression;
struct CsConstructorDeclaration;
struct CsConstantDeclarator;
struct CsConstantDeclaration;
struct CsVariableDeclarator;
struct CsVariableDeclaration;
struct CsArrayInitializer;
struct CsMethod;
struct CsPropertyAccessor;
struct CsProperty;
struct CsEventAccessor;
struct CsEventDeclarator;
struct CsEvent;
struct CsIndexer;
struct CsOperator;
struct CsConversionOperatorDeclaration;
struct CsDestructorDeclaration;
struct CsCompilationUnit;
struct CsMakeRefExpression;
struct CsRefTypeExpression;
struct CsRefValueExpression;
struct CsArgListExpression;

//------------------------------------------------------------------------------
// CsAstVisitor
//------------------------------------------------------------------------------

class CsAstVisitor
{
public:
	//virtual void visit ( CsUsingDirective * node ) {}
	virtual void visit ( CsUsingAliasDirective * node ) {}
	virtual void visit ( CsUsingNamespaceDirective * node ) {}
	virtual void visit ( CsTypeRef * node ) {}
	virtual void visit ( CsSimpleName * node ) {}
	virtual void visit ( CsLiteral * node ) {}
	virtual void visit ( CsEmbeddedTypeMemberAccess * node ) {}
	virtual void visit ( CsThisAccess * node ) {}
	virtual void visit ( CsBaseMemberAccess * node ) {}
	virtual void visit ( CsBaseIndexerAccess * node ) {}
	virtual void visit ( CsTypeofExpression * node ) {}
	virtual void visit ( CsCheckedExpression * node ) {}
	virtual void visit ( CsUncheckedExpression * node ) {}
	virtual void visit ( CsLockStatement * node ) {}
	virtual void visit ( CsSizeofExpression * node ) {}
	virtual void visit ( CsParenthesizedExpression * node ) {}
	virtual void visit ( CsNewObjectExpression * node ) {}
	virtual void visit ( CsNewArrayExpression * node ) {}
	virtual void visit ( CsInvocationExpression * node ) {}
	virtual void visit ( CsElementAccess * node ) {}
	virtual void visit ( CsMemberAccess * node ) {}
	virtual void visit ( CsPointerMemberAccess * node ) {}
	virtual void visit ( CsPostIncrementDecrementExpression * node ) {}
	virtual void visit ( CsBinaryExpression * node ) {}
	virtual void visit ( CsAsIsExpression * node ) {}
	virtual void visit ( CsConditionalExpression * node ) {}
	virtual void visit ( CsOperatorUnaryExpression * node ) {}
	virtual void visit ( CsPreIncrementDecrementExpression * node ) {}
	virtual void visit ( CsCastUnaryExpression * node ) {}
	virtual void visit ( CsAssignmentExpression * node ) {}
	virtual void visit ( CsExpressionList * node ) {}
	virtual void visit ( CsNamedArgument * node ) {}
	virtual void visit ( CsAttribute * node ) {}
	virtual void visit ( CsAttributeSection * node ) {}
	virtual void visit ( CsAttributes * node ) {}
	virtual void visit ( CsTypeBase * node ) {}
	virtual void visit ( CsClass * node ) {}
	virtual void visit ( CsStruct * node ) {}
	virtual void visit ( CsInterface * node ) {}
	virtual void visit ( CsEnumMember * node ) {}
	virtual void visit ( CsEnum * node ) {}
	virtual void visit ( CsFormalParameter * node ) {}
	virtual void visit ( CsFormalParameterList * node ) {}
	virtual void visit ( CsDelegate * node ) {}
	virtual void visit ( CsNamespace * node ) {}
	virtual void visit ( CsArgument * node ) {}
	virtual void visit ( CsArgumentList * node ) {}
	virtual void visit ( CsBlock * node ) {}
	virtual void visit ( CsLabel * node ) {}
	virtual void visit ( CsLabeledStatement * node ) {}
	virtual void visit ( CsEmptyStatement * node ) {}
	virtual void visit ( CsExpressionStatement * node ) {}
	virtual void visit ( CsDeclarationStatement * node ) {}
	virtual void visit ( CsLocalConstantDeclarator * node ) {}
	virtual void visit ( CsLocalConstantDeclaration * node ) {}
	virtual void visit ( CsIfStatement * node ) {}
	virtual void visit ( CsSwitchLabel * node ) {}
	virtual void visit ( CsSwitchSection * node ) {}
	virtual void visit ( CsSwitchStatement * node ) {}
	virtual void visit ( CsWhileStatement * node ) {}
	virtual void visit ( CsDoWhileStatement * node ) {}
	virtual void visit ( CsLocalVariableDeclarator * node ) {}
	virtual void visit ( CsLocalVariableDeclaration * node ) {}
	virtual void visit ( CsStatementExpressionList * node ) {}
	virtual void visit ( CsForStatement * node ) {}
	virtual void visit ( CsForeachStatement * node ) {}
	virtual void visit ( CsBreakStatement * node ) {}
	virtual void visit ( CsContinueStatement * node ) {}
	virtual void visit ( CsGotoStatement * node ) {}
	virtual void visit ( CsReturnStatement * node ) {}
	virtual void visit ( CsThrowStatement * node ) {}
	virtual void visit ( CsCatchClause * node ) {}
	virtual void visit ( CsTryStatement * node ) {}
	virtual void visit ( CsCheckedStatement * node ) {}
	virtual void visit ( CsUncheckedStatement * node ) {}
	virtual void visit ( CsUsingStatement * node ) {}
	virtual void visit ( CsUnsafeStatement * node ) {}
	virtual void visit ( CsFixedPointDeclarator * node ) {}
	virtual void visit ( CsFixedStatement * node ) {}
	virtual void visit ( CsStackAllocExpression * node ) {}
	virtual void visit ( CsConstructorDeclaration * node ) {}
	virtual void visit ( CsConstantDeclarator * node ) {}
	virtual void visit ( CsConstantDeclaration * node ) {}
	virtual void visit ( CsVariableDeclarator * node ) {}
	virtual void visit ( CsVariableDeclaration * node ) {}
	virtual void visit ( CsArrayInitializer * node ) {}
	virtual void visit ( CsMethod * node ) {}
	virtual void visit ( CsPropertyAccessor * node ) {}
	virtual void visit ( CsProperty * node ) {}
	virtual void visit ( CsEventAccessor * node ) {}
	virtual void visit ( CsEventDeclarator * node ) {}
	virtual void visit ( CsEvent * node ) {}
	virtual void visit ( CsIndexer * node ) {}
	virtual void visit ( CsOperator * node ) {}
	virtual void visit ( CsConversionOperatorDeclaration * node ) {}
	virtual void visit ( CsDestructorDeclaration * node ) {}
	virtual void visit ( CsCompilationUnit * node ) {}
	virtual void visit ( CsMakeRefExpression * node ) {}
	virtual void visit ( CsRefTypeExpression * node ) {}
	virtual void visit ( CsRefValueExpression * node ) {}
	virtual void visit ( CsArgListExpression * node ) {}
};

//------------------------------------------------------------------------------
// CsAstCallback
//------------------------------------------------------------------------------

class CsAstCallback
{
public:
	//virtual void callback ( CsUsingDirective * node ) {}
	virtual void callback ( CsUsingAliasDirective * node ) {}
	virtual void callback ( CsUsingNamespaceDirective * node ) {}
	virtual void callback ( CsTypeRef * node ) {}
	virtual void callback ( CsSimpleName * node ) {}
	virtual void callback ( CsLiteral * node ) {}
	virtual void callback ( CsEmbeddedTypeMemberAccess * node ) {}
	virtual void callback ( CsThisAccess * node ) {}
	virtual void callback ( CsBaseMemberAccess * node ) {}
	virtual void callback ( CsBaseIndexerAccess * node ) {}
	virtual void callback ( CsTypeofExpression * node ) {}
	virtual void callback ( CsCheckedExpression * node ) {}
	virtual void callback ( CsUncheckedExpression * node ) {}
	virtual void callback ( CsLockStatement * node ) {}
	virtual void callback ( CsSizeofExpression * node ) {}
	virtual void callback ( CsParenthesizedExpression * node ) {}
	virtual void callback ( CsNewObjectExpression * node ) {}
	virtual void callback ( CsNewArrayExpression * node ) {}
	virtual void callback ( CsInvocationExpression * node ) {}
	virtual void callback ( CsElementAccess * node ) {}
	virtual void callback ( CsMemberAccess * node ) {}
	virtual void callback ( CsPointerMemberAccess * node ) {}
	virtual void callback ( CsPostIncrementDecrementExpression * node ) {}
	virtual void callback ( CsBinaryExpression * node ) {}
	virtual void callback ( CsAsIsExpression * node ) {}
	virtual void callback ( CsConditionalExpression * node ) {}
	virtual void callback ( CsOperatorUnaryExpression * node ) {}
	virtual void callback ( CsPreIncrementDecrementExpression * node ) {}
	virtual void callback ( CsCastUnaryExpression * node ) {}
	virtual void callback ( CsAssignmentExpression * node ) {}
	virtual void callback ( CsExpressionList * node ) {}
	virtual void callback ( CsNamedArgument * node ) {}
	virtual void callback ( CsAttribute * node ) {}
	virtual void callback ( CsAttributeSection * node ) {}
	virtual void callback ( CsAttributes * node ) {}
	virtual void callback ( CsTypeBase * node ) {}
	virtual void callback ( CsClass * node ) {}
	virtual void callback ( CsStruct * node ) {}
	virtual void callback ( CsInterface * node ) {}
	virtual void callback ( CsEnumMember * node ) {}
	virtual void callback ( CsEnum * node ) {}
	virtual void callback ( CsFormalParameter * node ) {}
	virtual void callback ( CsFormalParameterList * node ) {}
	virtual void callback ( CsDelegate * node ) {}
	virtual void callback ( CsNamespace * node ) {}
	virtual void callback ( CsArgument * node ) {}
	virtual void callback ( CsArgumentList * node ) {}
	virtual void callback ( CsBlock * node ) {}
	virtual void callback ( CsLabel * node ) {}
	virtual void callback ( CsLabeledStatement * node ) {}
	virtual void callback ( CsEmptyStatement * node ) {}
	virtual void callback ( CsExpressionStatement * node ) {}
	virtual void callback ( CsDeclarationStatement * node ) {}
	virtual void callback ( CsLocalConstantDeclarator * node ) {}
	virtual void callback ( CsLocalConstantDeclaration * node ) {}
	virtual void callback ( CsIfStatement * node ) {}
	virtual void callback ( CsSwitchLabel * node ) {}
	virtual void callback ( CsSwitchSection * node ) {}
	virtual void callback ( CsSwitchStatement * node ) {}
	virtual void callback ( CsWhileStatement * node ) {}
	virtual void callback ( CsDoWhileStatement * node ) {}
	virtual void callback ( CsLocalVariableDeclarator * node ) {}
	virtual void callback ( CsLocalVariableDeclaration * node ) {}
	virtual void callback ( CsStatementExpressionList * node ) {}
	virtual void callback ( CsForStatement * node ) {}
	virtual void callback ( CsForeachStatement * node ) {}
	virtual void callback ( CsBreakStatement * node ) {}
	virtual void callback ( CsContinueStatement * node ) {}
	virtual void callback ( CsGotoStatement * node ) {}
	virtual void callback ( CsReturnStatement * node ) {}
	virtual void callback ( CsThrowStatement * node ) {}
	virtual void callback ( CsCatchClause * node ) {}
	virtual void callback ( CsTryStatement * node ) {}
	virtual void callback ( CsCheckedStatement * node ) {}
	virtual void callback ( CsUncheckedStatement * node ) {}
	virtual void callback ( CsUsingStatement * node ) {}
	virtual void callback ( CsUnsafeStatement * node ) {}
	virtual void callback ( CsFixedPointDeclarator * node ) {}
	virtual void callback ( CsFixedStatement * node ) {}
	virtual void callback ( CsStackAllocExpression * node ) {}
	virtual void callback ( CsConstructorDeclaration * node ) {}
	virtual void callback ( CsConstantDeclarator * node ) {}
	virtual void callback ( CsConstantDeclaration * node ) {}
	virtual void callback ( CsVariableDeclarator * node ) {}
	virtual void callback ( CsVariableDeclaration * node ) {}
	virtual void callback ( CsArrayInitializer * node ) {}
	virtual void callback ( CsMethod * node ) {}
	virtual void callback ( CsPropertyAccessor * node ) {}
	virtual void callback ( CsProperty * node ) {}
	virtual void callback ( CsEventAccessor * node ) {}
	virtual void callback ( CsEventDeclarator * node ) {}
	virtual void callback ( CsEvent * node ) {}
	virtual void callback ( CsIndexer * node ) {}
	virtual void callback ( CsOperator * node ) {}
	virtual void callback ( CsConversionOperatorDeclaration * node ) {}
	virtual void callback ( CsDestructorDeclaration * node ) {}
	virtual void callback ( CsCompilationUnit * node ) {}
	virtual void callback ( CsMakeRefExpression * node ) {}
	virtual void callback ( CsRefTypeExpression * node ) {}
	virtual void callback ( CsRefValueExpression * node ) {}
	virtual void callback ( CsArgListExpression * node ) {}
};

//------------------------------------------------------------------------------

#endif // _AST_VISITOR_H_
